#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <process.h>
#include <stdio.h>

typedef void interrupt (*isr)();

extern isr old9;
void interrupt i09();
extern unsigned int _heaplen=1024;
extern unsigned int _stacklen=1024;

#define PUT_ERR(x) _write(2,(x),sizeof((x))-1);
#define PUT_MSG(x) _write(1,(x),sizeof((x))-1);
#define isnum(x) ('0'<=(x) && '9'>=(x))

void instructions()
{
    PUT_ERR("\r\n\tRun prince of persia from any level\r\n\n"
            "\tMake sure prince.exe is in the current directory\r\n\n");
}

char *_gets(char *s)
{
    char ch;
    register int l;
    l=0;
    while(_read(0,&ch,1),ch!='\r') s[l++]=ch;
    s[l]='\0';
}

int _atoi(char *s)
{
    register int j,ans;
    j=0;
    while(!isnum(s[j])) j++;
    ans=s[j++]-'0';
    while(isnum(s[j]))
     ans=10*ans+(s[j++]-'0');
    return ans;
}


main()
{
	int i,infile,l;
	char buf[6];
    char id[6];
    char line[40];

	id[0] = 199;	/* $C7 */
	id[1] = 6;		/* $06 */
	id[2] = 208;	/* $D0 */
	id[3] = 66;		/* $42 */
	id[4] = 0;
	id[5] = 0;

    if ( -1==(infile = _open("prince.exe",O_RDWR)) )  {
        PUT_ERR("\r\n\n\tCannot open prince.exe for reading/writing.\r\n");
		instructions();
        return 1;
	}

	lseek(infile,(long) 20251,0);
	/* 20251 is the offset of an instruction I look for.  The
	instruction is:  mov    word ptr[42D0], 0000
	   The instruction immediately after is the one that gets modified.
	new instruction: mov ax,##, where ## is the level in hex.
	*/
    _read(infile,buf,6);
	for ( i = 0; i < 6; i++ )
		if (buf[i] != id[i]) {
            _close(infile);
	    PUT_ERR("\tLooks like you have a different copy of\r\n"
                   "\tPOP than I do.  Look for the sequence\r\n"
		   "\tC706D0420000 (hex) in PRINCE.EXE, and replace\r\n"
                   "\tthe offset of this instruction with 20251 in\r\n"
                   "\tthe source.\r\n");
             return 2;
			}
    PUT_MSG("\r\n\n\tAt any time in the game hit a key from 3 to 0 to set health!");
    PUT_MSG("\r\n\n\tLevel to start [0,1..13,14] : ");
    _gets(line);
    buf[1]=_atoi(line);
    buf[0]=184;
    buf[2]=0;
    PUT_MSG("\r\n\n\tExecuting Prince of Persia ..... ");
    if (_write(infile,buf,3) == -1)
        PUT_ERR("Error in writing\r\n");
    _close(infile);
    old9=getvect(0x09);
    setvect(0x09,i09);
    spawnl(P_WAIT,"prince.exe","prince.exe",NULL);
    setvect(0x09,old9);
}
